﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class HookBehaviour : MonoBehaviour
{
    [SerializeField]
    private LineRenderer lr;
    [SerializeField]
    private Transform player;

    [SerializeField]
    private Rigidbody rb;

    private void Awake()
    {
        rb = GetComponent<Rigidbody>();
        gameObject.SetActive(false);
    }

    private void Update()
    {
        Debug.Log(rb.velocity);
        lr.SetPosition(0, transform.position);
        lr.SetPosition(1, player.position);
    }

    private void OnCollisionEnter(Collision collision)
    {
        rb.velocity = Vector3.zero;
        rb.isKinematic = true;
    }

    public void EnableHook(Vector3 velocity)
    {
        lr.enabled = true;
        lr.SetPosition(0, transform.position);
        lr.SetPosition(1, player.position);
        rb.isKinematic = false;
        rb.velocity = velocity;
    }

    public void DisableHook()
    {
        lr.enabled = false;
        gameObject.SetActive(false);
    }
}
