﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(CharacterController))]
public class PlayerController : MonoBehaviour
{
    public float distance = 10.0f;
    private CharacterController cc;

    float velocityY = 0.0f;
    const float gravity = 9.8f;

    public HookBehaviour hook;

#if UNITY_EDITOR
    private void OnDrawGizmos()
    {
        Gizmos.DrawLine(transform.position, (transform.position - Camera.main.transform.position) * 10);
    }
#endif

    private void Start()
    {
        cc = GetComponent<CharacterController>();
        Cursor.lockState = CursorLockMode.Locked;
    }
    private void Update()
    {
        float vertical = Input.GetAxis("Vertical");
        float horizontal = Input.GetAxis("Horizontal");

        if (Input.GetMouseButtonDown(1))
        {
            if (!hook.gameObject.activeSelf)
            {
                FireHook();
            }
            else
                ReturnHook();
        }


        if (Input.GetButtonDown("Jump") && cc.isGrounded)
            velocityY = 5.0f;
        if (!cc.isGrounded)
            velocityY -= gravity * Time.deltaTime;
        cc.Move(horizontal * transform.right + vertical * transform.forward + new Vector3(0, velocityY, 0) * Time.deltaTime);
    }

    private void LateUpdate()
    {

    }

    private void FireHook()
    {
        hook.gameObject.SetActive(true);
        hook.transform.position = transform.position;
        hook.EnableHook((transform.position - Camera.main.transform.position) * 50);
    }

    private void ReturnHook()
    {
        hook.DisableHook();
    }
}
